import java.io.*;

public class DemoWriter
{
    public static void fileWriter() throws IOException {
        FileWriter fw = new FileWriter("out.txt");
        fw.write('a');
        fw.write(System.getProperty("line.separator"));
        fw.write("ahoj");
        fw.write("č");
        fw.close(); // toto neni uplne spravne, podrobnosti pozdeji
        fw.write("a");
    }
    
    public static void bufferedWriter() throws IOException {
        //FileWriter fw = new FileWriter("out.txt");
        BufferedWriter bw = new BufferedWriter(new FileWriter("out.txt"));
        
        bw.write('a');
        bw.newLine();
        bw.write("ahoj");
        bw.write("č");
        
        //fw.write("neco");
        
        //fw.close();
        bw.close();
    }
    
    public static void bufferedWriter2() throws IOException {
        BufferedWriter bw = new BufferedWriter(new FileWriter("out.txt"));
        
        try {
            bw.write('a');
            bw.newLine();
            bw.write("ahoj");
            bw.write("č");
        } finally {
            bw.close();
        }
    }
    
    public static void bufferedWriter3() {
        BufferedWriter bw = null;
        try {
            bw = new BufferedWriter(new FileWriter("out.txt"));
            bw.write('a');
            bw.newLine();
            bw.write("ahoj");
            bw.write("č");
        } catch(IOException ex) {
            ex.printStackTrace();
        } finally {
            if (bw != null) {
                try {
                    bw.close();
                } catch(IOException ex) {
                    ex.printStackTrace();
                }
            }
        }
    }
    
    public static void bufferedWriter4() {
        try {
            BufferedWriter bw = new BufferedWriter(new FileWriter("out.txt"));
            try {
                bw.write('a');
                bw.newLine();
                bw.write("ahoj");
                bw.write("č");
            } finally {
                bw.close();
            }
        } catch(IOException ex) {
            ex.printStackTrace();
        }
    }
    
    public static void bufferedWriter5() throws IOException {
        try (BufferedWriter bw = new BufferedWriter(new FileWriter("out.txt"))) {
            bw.write('a');
            bw.newLine();
            bw.write("ahoj");
            bw.write("č");
        }
    }
    
    public static void bufferedWriter5(Writer w) throws IOException { // TAKTO NE!!!
        try (BufferedWriter bw = new BufferedWriter(w)) {
            bw.write('a');
            bw.newLine();
            bw.write("ahoj");
            bw.write("č");
        }
    }
    
    public static void bufferedWriter(Writer writer) throws IOException {
        BufferedWriter bw = new BufferedWriter(writer);
        
        bw.write('a');
        bw.newLine();
        bw.write("ahoj");
        bw.write("č");
        
        bw.flush();
        //bw.close();
    }
}
